/* $Id: com.c,v 1.3 1993/08/22 04:53:48 nils Exp $ */

#include "config.h"
#include "externs.h"

static int is_banned P((dbref, char *));
static int is_on_channel P((dbref,char *));
static int is_on_channel(player,chan)
     dbref player;
     char *chan;
{
  char *clist;
  char *clbegin;
  static char buf[1025];

  sprintf(buf,"%s ",atr_get(player,A_CHANNEL));
  clbegin=clist=buf;
  while(*clist) {
    if(strchr(clist,' '))
      *strchr(clist,' ') ='\0';    /* insert null after first channel name */
    if(!strcmp(clist,chan)) {      /* if listitem = channel, return string index
                                    * of channel. */
      return (clist-clbegin);
    }
    clist+=strlen(clist)+1;        /* Otherwise, move beginning of clist past
                                    * end of first channel name. */
  }
  return -1;
}

extern void com_send (channel, message)
     char *channel;
     char *message;
{
  struct descriptor_data *d;
  for (d = descriptor_list; d; d=d->next)
    if (d->state==CONNECTED && d->player>0 && is_on_channel(d->player, channel)>=0) {
      if (db[d->player].flags & PLAYER_NOBEEP) {
        if (db[d->player].flags & PLAYER_ANSI)
          queue_string(d, parse_color_nobeep(message));
        else
          queue_string(d, strip_color_nobeep(message));
      } else {
        if (db[d->player].flags & PLAYER_ANSI)
          queue_string(d, parse_color(message)); 
        else
          queue_string(d, strip_color(message));
      }
      queue_string(d, "\n");
    }
}
static void com_who P((dbref, char *));
static void com_who (player, channel)
     dbref player;
     char *channel;
{
  struct descriptor_data *d;
  for (d = descriptor_list; d; d=d->next)
    if (d->state==CONNECTED && d->player>0 && is_on_channel(d->player, channel)>=0) {
      notify(player,tprintf("%s is on channel %s.",
			    unparse_object(player,d->player),channel));
    }
  notify(player,tprintf ("--- %s ---",channel));
}

void do_com(player, arg1, arg2)
     dbref player;
     char *arg1;
     char *arg2;
{
  static char buf2[1024];
  dbref toplayer;
  if (!*arg1) {
    static char buf[1024];
    char *s;
    strcpy(buf,atr_get(player,A_CHANNEL));
    if ((s=strchr(buf,' ')))
      *s = '\0';
    arg1 = buf;
  }
  if (!*arg1) {
    notify(player,"No channel.");
    return;
  }
  if (strchr(arg1,' ')) {
    notify(player,"You're spacey.");
    return;
  }
  if (!string_compare(arg2,"who"))
    com_who(player,arg1);
  else {
    char buf[2048];
    if (Typeof(player) != TYPE_PLAYER && !power(player,POW_SPOOF)) {
      notify(player,"Non-players can not send +com messsages.");
      return;
    }
    if(is_banned(player, arg1)>=0) {
      notify(player, "You have been banned from that channel.");
      return;
    }
    switch(*arg2) {
      case POSE_TOKEN:
      case NOSP_POSE:
        sprintf (buf, "[%s] %s%s %s",arg1,db[player].cname,
          (*arg2 == NOSP_POSE)?"\'s":"",arg2+1);
        break;
      case TO_TOKEN:
        arg2++;
        strcpy(buf2, arg2);
        if (strchr(buf2, ' ') != NULL) {
          *strchr(buf2, ' ') = '\0';
          arg2 += strlen(buf2)+1;
        } else
          arg2 += strlen(buf2);
        toplayer = lookup_player(buf2);
        if (toplayer != NOTHING)
          strcpy(buf2,db[toplayer].cname);
        if (*arg2 == POSE_TOKEN)
          sprintf(buf, "[%s] [to %s] %s %s", arg1, buf2, db[player].cname, arg2+1);
        else if (*arg2 == NOSP_POSE)
          sprintf(buf, "[%s] [to %s] %s's %s", arg1, buf2, db[player].cname, arg2+1);
        else
          sprintf(buf, "[%s] %s [to %s]: %s", arg1, db[player].cname, buf2, arg2);
        break;
      case THINK_TOKEN:
        sprintf(buf, "[%s] %s . o O ( %s )",arg1, db[player].cname, arg2+1);
        break;
      default:
        sprintf(buf, "[%s] %s: %s", arg1, db[player].cname, arg2);
        break;
    }

    com_send(arg1, buf);
    if (is_on_channel(player,arg1)<0)
      notify(player,"Your +com has been sent.");
  }
}

void do_channel(player,arg1)
     dbref player;
     char *arg1;
{
  ptype k;
  char buf[1024];
  
  if(*arg1 == '\0') {
    if(*atr_get(player,A_CHANNEL))
      notify(player,tprintf("You are currently on the following channels: %s",
			    atr_get(player,A_CHANNEL)));
    else {
      notify(player,"You aren't currently on any channels. For a general chatting channel, turn to");
      notify(player,"channel 'public'");
    }
  } else if(*arg1 == '+') {
    arg1++;
    if(Typeof(player)!=TYPE_PLAYER) {
      notify(player,"As of yet, non-players cannot talk on channels.");
      return;
    }
    if (!db[player].pows) return;
    k= *db[player].pows;
    if(*arg1 == '*' &&
       !(k==CLASS_ADMIN ||
	 k==CLASS_DIR)) {
      notify(player,perm_denied());
      return;
    }
    if(*arg1 == '.' &&
       !(k==CLASS_DIR ||
	 k==CLASS_ADMIN ||
	 k==CLASS_BUILDER)) {
      notify(player,perm_denied());
      return;
    }
    if(*arg1 == '_' &&
       !(k==CLASS_DIR ||
	 k==CLASS_ADMIN ||
	 k==CLASS_BUILDER ||
	 k==CLASS_OFFICIAL ||
	 k==CLASS_JUNOFF)) {
      notify(player,perm_denied());
      return;
    }
    if (strchr(arg1,' ')) {
      notify(player,"Sorry, channel names can not have spaces in them.");
      return;
    }
    if (!*arg1) {
      notify(player,"What channel?");
      return;
    }
    if (is_banned(player,arg1)>=0) {
      notify(player, "You have been banned from that channel.");
      return;
    }
    if (is_on_channel(player,arg1)>=0) {
      notify(player,"You are already on that channel.");
      return;
    }
    if(!*atr_get(player,A_CHANNEL))
      atr_add(player,A_CHANNEL,arg1);
    else
      atr_add(player,A_CHANNEL,tprintf("%s %s",arg1,atr_get(player,A_CHANNEL)));
    sprintf(buf,"[%s] %s has joined this channel.",arg1 , db[player].cname);
    com_send(arg1,buf);
    notify(player,tprintf("%s added to your channel list.",arg1));
  } else if(*arg1 == '-') {
    int i;
    char *end;
    char buf2[1024];

    arg1++;
    
    if (strchr(arg1,' ') || !*arg1) {
      notify(player,"Sorry, channel names can not have spaces in them.");
      return;
    }
    i = is_on_channel(player, arg1);
    if (i<0) {
      notify(player,"You aren't on that channel.");
      return;
    }
    strcpy(buf,atr_get(player,A_CHANNEL));
    end = strchr(buf+i,' ');
    if (!end)
      end=strchr(buf+i,'\0');
    else
      end++;
    strcpy (buf2, atr_get(player,A_CHANNEL));
    strcpy(buf2+i, end);
    if ((end=strchr(buf2,'\0')) && *--end==' ') *end='\0';

    notify(player,tprintf("%s has been deleted from your channel list.",
			  arg1));
    sprintf(buf,"[%s] %s has left this channel.",arg1,db[player].cname);
    com_send(arg1,buf);
    atr_add (player, A_CHANNEL, buf2);
  } else {
    notify(player,"Usage:");
    notify(player,"  +channel +<channel>    :adds a channel");
    notify(player,"  +channel -<channel>    :deletes a channel");
    notify(player,"  +channel               :lists your channels.");
    notify(player,"For a general chatting channel, try channel 'public'.");
  }
}

void do_ban(player, arg1, arg2)
     dbref player;
     char *arg1;
     char *arg2;
{
  dbref victim;
  int i;

  if(!power(player,POW_BAN)) {
    notify(player,perm_denied());
    return;
  }

  init_match(player, arg1, TYPE_PLAYER);
  match_neighbor();
  match_here();
  if(power(player, POW_REMOTE)) {
    match_player();
    match_absolute();
  }

  if((victim = noisy_match_result()) == NOTHING)
    return;

  if(!has_pow(player, victim, POW_BAN)) {
    log_important(tprintf("%s failed to: +ban %s=%s", unparse_object_a(player,player),
                  unparse_object_a(victim, victim), arg2));
    notify(player, perm_denied());
    return;
  }

  if(strchr(arg2,' ') || !*arg2) {
    notify(player, "Sorry, channel names can not have spaces in them.");
    return;
  }

  if(is_banned(player,arg2)>=0) {
    notify(player, tprintf("%s has already been banned from %s.",
           db[player].name, arg2));
    return;
  }

  if(!*atr_get(victim,A_BANNED))
    atr_add(victim,A_BANNED,arg2);
  else
    atr_add(victim,A_BANNED,tprintf("%s %s",arg2,atr_get(victim,A_BANNED)));

  i = is_on_channel(victim, arg2);
  if(i >= 0) {
    char *end;
    char buf[1024];
    char buf2[1024];
    strcpy(buf, atr_get(victim,A_CHANNEL));
    end = strchr(buf+i,' ');
    if(!end)
      end=strchr(buf+i,'\0');
    else
      end++;
    strcpy(buf2,atr_get(victim,A_CHANNEL));
    strcpy(buf2+i,end);
    if((end=strchr(buf2,'\0')) && *--end==' ') *end='\0';
    atr_add(victim,A_CHANNEL,buf2);
  }

  log_important(tprintf("%s executed: +ban %s=%s",
         unparse_object_a(player,player), unparse_object_a(victim,victim), arg2));
  notify(player,tprintf("%s banned from channel %s.",
         unparse_object(player,victim),arg2));
  notify(victim,tprintf("You have been banned from channel %s by %s.",arg2,
         unparse_object(victim,player)));
  com_send(arg2,tprintf("[%s] %s has been banned from this channel.",arg2,
                        db[victim].cname));
}

void do_unban(player, arg1, arg2)
     dbref player;
     char *arg1;
     char *arg2;
{
  dbref victim;
  int i;
  char *end;
  char buf[1024];
  char buf2[1024];

  if(!power(player,POW_BAN)) {
    notify(player,perm_denied());
    return;
  }

  init_match(player, arg1, TYPE_PLAYER);
  match_neighbor();
  match_here();
  if(power(player, POW_REMOTE)) {
    match_player();
    match_absolute();
  }

  if((victim = noisy_match_result()) == NOTHING)
    return;

  if(!has_pow(player,victim,POW_BAN)) {
    notify(player,tprintf("You don't have the authority to unban %s.",
           unparse_object(player,victim)));
    return;
  }

  if(strchr(arg2,' ') || !*arg2) {
    notify(player, "Sorry, channel names can not have spaces in them.");
    return;
  }

  i = is_banned(victim,arg2);
  if(i<0) {
    notify(player, tprintf("%s is not banned from channel %s.",
           unparse_object(player,victim),arg2));
    return;
  }

  strcpy(buf,atr_get(player,A_BANNED));
  end = strchr(buf+i,' ');
  if (!end)
    end=strchr(buf+i,'\0');
  else
    end++;
  strcpy(buf2,atr_get(victim,A_BANNED));
  strcpy(buf2+i,end);
  if ((end=strchr(buf2,'\0')) && *--end==' ') *end='\0';
  atr_add(victim,A_BANNED,buf2);

  notify(player,tprintf("%s may now join channel %s again.",
         unparse_object(player, victim),arg2));
  notify(victim,tprintf("%s has allowed you to join channel %s again.",
         unparse_object(victim,player),arg2));
}
  
static int is_banned(player,chan)
     dbref player;
     char *chan;
{
  char *blist;
  char *blbegin;
  static char buf[1025];

  sprintf(buf, "%s ", atr_get(player,A_BANNED));
  blbegin=blist=buf;
  while(*blist) {
    if(strchr(blist,' '))
      *strchr(blist,' ') = '\0';
    if(!strcmp(blist,chan))
      return (blist-blbegin);  
    blist+=strlen(blist)+1;
  }
  return -1;
}
