#include "externs.h"
#include "http.h"

#include <fcntl.h>
#include <sys/socket.h>

struct dd_str {
  int fd;
  struct sockaddr info;
  char *authent;
};


void generate_authent(authent)
  char *authent;
{
  static int counter=0;
  int x;
  char *passchar=
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

  sprintf(authent,"/%d-",counter++);

  for(x=0;(x<20) && (authent[x]!='-');x++);
  for(x++;(x<21);x++)
    authent[x]=passchar[rand() % 61];
  authent[21]='\0';
}

void do_htbuff(player, name, newtext)
  dbref player;
  char *name, *newtext;
{
  dbref thing;
  int dest, x;

  if(!power(player,POW_HTTP)) {
    notify(player,"You can't do that!");
    return;
  }

  if((thing = match_thing(player, name)) == NOTHING)
    return;

  if(Typeof(thing) != TYPE_PLAYER) {
    notify(player,tprintf("%s is not a player.",db[thing].name));
    return;
  }

  if(!(db[thing].flags & CONNECT)) {
    notify(player,tprintf("%s is not connected.",db[thing].name));
    return;
  }

  if(db[thing].http_cnt==(-1)) {
    db[thing].http=(struct http_struct*)malloc(sizeof(struct http_struct));
    db[thing].http_cnt++;
  }

  dest=(-1);
  for(x=db[thing].http_cnt;x>=1;x--) {
    if(db[thing].http[x].control==player) {
      dest=x;
      x=(-1);
    }
  }
  if(dest==(-1)) {
    dest=++db[thing].http_cnt;
    db[thing].http=(struct http_struct*)realloc(db[thing].http,
      sizeof(struct http_struct)*(1+dest));
    db[thing].http[dest].lines=(-1);
    db[thing].http[dest].text=(char**)malloc(1);
    db[thing].http[dest].control=player;
    db[thing].http[dest].user=thing;
    if(!(db[player].flags & QUIET))
      notify(player,tprintf("%s - HyperText started.",db[thing].cname));
  }

  db[thing].http[dest].text=(char**)realloc(db[thing].http[dest].text,
    sizeof(char*)*(++db[thing].http[dest].lines+1));
  db[thing].http[dest].text[db[thing].http[dest].lines]=
    malloc(sizeof(char)*(1+strlen(newtext)));
  strcpy(db[thing].http[dest].text[db[thing].http[dest].lines],newtext);

  if(!(db[player].flags & QUIET))
    if(db[thing].http[dest].lines)
      notify(player,tprintf("%s - HyperText appended.",db[thing].cname));
}


void do_htout(player, name)
  dbref player;
  char *name;
{
  int x, dest;
  dbref thing;

  if(!power(player,POW_HTTP)) {
    notify(player,"You can't do that!");
    return;
  }

  if((thing = match_thing(player, name)) == NOTHING)
    return;

  dest=(-1);
  for(x=db[thing].http_cnt;x>=1;x--)
    if(db[thing].http[x].control==player) {
      dest=x;
      x=(-1);
    }

  if(dest==(-1)) {
    notify(player,"No HyperText to send!");
    return;
  }

  http=(struct http_struct*)realloc(http,
    sizeof(struct http_struct)*(++http_cnt+1));

  http[http_cnt]=db[thing].http[dest];
  generate_authent(http[http_cnt].authent);

  strcpy(db[thing].http[0].authent,http[http_cnt].authent);
  db[thing].http[0].control=http[http_cnt].control;
  db[thing].http[0].user=http[http_cnt].user;

  notify(thing,tprintf("HTTP: http://flipside.lutz.com:%d%s",
    inet_port+1, http[http_cnt].authent));

  db[thing].http[dest]=db[thing].http[db[thing].http_cnt];

  db[thing].http=(struct http_struct*)realloc(db[thing].http,
    sizeof(struct http_struct)*db[thing].http_cnt--);

  if(!(db[player].flags & QUIET))
    notify(player,tprintf("%s - HyperText sent.",db[thing].cname));
}


void do_htdir(player, name, url)
  dbref player;
  char *name, *url;
{
  dbref thing;

  if(!power(player,POW_HTTP)) {
    notify(player,"You can't do that!");
    return;
  }

  if((thing = match_thing(player, name)) == NOTHING)
    return;

  notify(thing,tprintf("HTTP: %s",url));

  if(!(db[player].flags & QUIET))
    notify(player,"URL sent.");
}

void do_htconn(player, arg1) /* for testing purposes only */
  dbref player;
  char *arg1;
{
  int x, dest;

  if(!power(player,POW_HTTP)) {
    notify(player,"You can't do that!");
    return;
  }

  if(!strcasecmp(arg1,"special")) {
    notify(player,tprintf("http_cnt=%d",http_cnt));
    return;
  }

  if(arg1[0]=='\0') {
    notify(player,"--- HyperTexts waiting to go out ---");
    for(x=http_cnt;x>=0;x--)
      notify(player,tprintf("  %s: %d lines  (#%d -> #%d)",http[x].authent,
        http[x].lines+1, http[x].control,http[x].user));
    notify(player,"---");
    return;
  }

  dest=(-1);
  for(x=http_cnt;x>=0;x--)
    if(!strcasecmp(http[x].authent,arg1)) {
      dest=x;
      x=(-1);
    }

  if(dest==(-1)) {
    notify(player,"No waiting HyperTexts match that name.");
    return;
  }

  notify(player,tprintf("--- HyperText, %d lines ---",http[dest].lines+1));
  for(x=0;x<=http[dest].lines;x++)
    notify(player,http[dest].text[x]);
  notify(player,"---");

  for(x=http[dest].lines;x>=0;x--)
    free(http[dest].text[x]);
  free(http[dest].text);

  if(dest!=http_cnt)
    http[dest]=http[http_cnt];

  http=(struct http_struct*)realloc(http,
    sizeof(struct http_struct)*http_cnt--);
}

void do_htlist(player, name, second)
  dbref player;
  char *name, *second;
{
  dbref thing, thing2;
  int x, dest;

  if(!power(player,POW_HTTP)) {
    notify(player,"You can't do that!");
    return;
  }

  if((thing = match_thing(player, name)) == NOTHING)
    return;

  if(!strcasecmp(second,"special")) {
    notify(player,tprintf("db[%d].http_cnt=%d",thing,db[thing].http_cnt));
    return;
  }

  if(second[0]=='\0') {
    notify(player,"--- HyperText WIP's ---");
    for(x=db[thing].http_cnt;x>=1;x--)
      notify(player,tprintf("  %s: %d lines", 
        unparse_object(player,db[thing].http[x].control),
        db[thing].http[x].lines+1));
    notify(player,"---");
  }
  else {
    dest=(-1);
    if((thing2 = match_thing(player, second)) == NOTHING)
      return;
     for(x=db[thing].http_cnt;x>=1;x--)
       if(db[thing].http[x].control==thing2) {
         dest=x;
         x=(-1);
       }
    if(dest==(-1)) {
      notify(player,"No such HyperText WIP.");
      return;
    }

    notify(player,tprintf("--- HyperText WIP: %d lines ---",
      db[thing].http[dest].lines+1));
    for(x=0;x<=db[thing].http[dest].lines;x++)
      notify(player,db[thing].http[dest].text[x]);
    notify(player,"---");
  }
}


void handle_http_port(psock)
  int psock;
{
  static int stat=1;
  static int ddc=0;
  static struct dd_str *dd;

  int x, y, size;
  char readbuf[1024], *buf;

  if(stat) {
    dd=(struct dd_str*)malloc(sizeof(struct dd_str));
    stat=0;
  }

  size=sizeof(struct sockaddr);
  for(dd[ddc].fd=0;
   (dd[ddc].fd=accept(psock,&dd[ddc].info,&size))!=(-1);
   ) {
    /* printf("accepted: dd[%d].fd=%d\n",ddc,dd[ddc].fd); */
    fcntl(dd[ddc].fd,F_SETFL,FNDELAY);
    dd=(struct dd_str*)realloc(dd,sizeof(struct dd_str)*(++ddc+1));
    dd[ddc].fd=0;
    dd[ddc].authent=(char*)malloc(sizeof(char));
    dd[ddc].authent[0]='\0';
  }

  for(x=0;x<ddc;x++) {
    switch(size=read(dd[x].fd,readbuf,1023)) {
    case -1:
      break;
    case 0:
      /* printf("dd[%d].fd=%d disconnected\n",x,dd[x].fd); */
      free(dd[x].authent);
      dd[x]=dd[ddc];
      dd=(struct dd_str*)realloc(dd,sizeof(struct dd_str)*ddc--);
      break;
    default:
/* PARSE BROWSER REQUEST */
      readbuf[size]='\0';
      for(buf=readbuf;buf[0]!='\0';) {
        if(buf[0]=='\n' || buf[0]=='\r') {
/* printf("spitting filename\n"); */
/* printf("'%s'\n",dd[x].authent); */
          http_out(dd[x].fd,dd[x].authent);
          close(dd[x].fd);
          free(dd[x].authent);
          dd[x]=dd[ddc];
          dd=(struct dd_str*)realloc(dd,sizeof(struct dd_str)*ddc--);
          buf[0]='\0';
        }
        else {
          if(!strncmp(buf,"GET ",4)) {
            for(y=4;(y<size) && (buf[y]==' ');y++);
            buf+=y;
            size-=y;
              for(y=0;(y<size) && (buf[y]!='\n');y++);
              for(;(y>=0) && (buf[y]!=' ');y--);
            if(!strncmp(buf+y," HTTP/1.0\n",9)) {
              for(;(y>=0) && (buf[y]==' ');y--); y++;
              dd[x].authent=(char*)realloc(dd[x].authent,sizeof(char)*(y+1));
              strncpy(dd[x].authent,buf,y);
              dd[x].authent[y]='\0';
              buf=strchr(buf,'\n');
              if(buf)
                buf++;
              else {
                buf=readbuf;
                buf[0]='\0';
              }
            }
            else {
              buf=strchr(buf,'\n');
              if(buf) 
                buf++;
              else {
                buf=readbuf;
                buf[0]='\0';
              }
            }
          }
          else {
            buf=strchr(buf,'\n');
            if(buf)
              buf++;
            else {
              buf=readbuf;
              buf[0]='\0';
            }
          }
        }
      }
      break;
    }
  }

}


void http_out(fd, authent)
  int fd;
  char *authent;
{
  int x, dest;
  char outbuf[1024];

  if(!strncasecmp(authent,"/response?",10)) {
    http_in(fd, authent+10);
    return;
  }

  dest=(-1);
  for(x=http_cnt;x>=0;x--)
    if(!strcasecmp(http[x].authent,authent)) {
      dest=x;
      x=(-1);
    }

  if(dest==(-1)) {
    write(fd,"No such URL!\n",strlen("No such URL!\n"));
    return;
  }

  for(x=0;x<=http[dest].lines;x++) {
    if(!strcmp(http[dest].text[x],"AUTHENT"))
      sprintf(outbuf,"<INPUT TYPE=hidden NAME=authent VALUE=%d%s>\n",
        http[dest].user, authent);
    else
      sprintf(outbuf,"%s\n",http[dest].text[x]);
    write(fd,outbuf,strlen(outbuf));
  }

  for(x=http[dest].lines;x>=0;x--)
    free(http[dest].text[x]);
  free(http[dest].text);

  if(dest!=http_cnt)
    http[dest]=http[http_cnt];

  http=(struct http_struct*)realloc(http,
    sizeof(struct http_struct)*http_cnt--);
}

void http_in(fd, args)
  int fd;
  char *args;
{
  char buf[1024], *wbuf, *authstr;
char buf2[1024];
  int x, y, size;
  dbref thing;

  authstr=(char*)NULL;
  size=strlen(args)-1;
  wbuf=buf;

  for(x=y=0;x<size;x++) {
    if(args[x]=='&') {
      buf[y++]='\0';
      wbuf=buf+y;
    }
    else if(args[x]=='+') {
      buf[y++]=' ';
    }
    else if(args[x]=='=') {
      buf[y++]='=';
      if(!strncasecmp(wbuf,"arg",3) && (wbuf[3]<='9' && wbuf[3]>='0') 
       && wbuf[4]=='=')
        wptr[hex2dec(wbuf[3])]=buf+y;
      if(!strncasecmp(wbuf,"authent=",8))
        authstr=buf+y;
    }
    else if(args[x]=='%') {
      buf[y++]=(char)((16*hex2dec(args[++x]))+hex2dec(args[++x]));
      if((buf[y-1]<31) || (buf[y-1]>126)) y--;
    }
    else if((args[x]>30) && (args[x]<127)) buf[y++]=args[x];
  }
  for(;x<size+1;x++) if((args[x]>30) && (args[x]<127)) buf[y++]=args[x];
  buf[y]='\0';

  if(authstr==(char*)NULL) {
    write(fd,"bad authstr\n",12);
    return;
  }

  size=strlen(authstr);
  for(x=0;(x<size) && (authstr[x]!='/');x++);
  authstr[x++]='\0';
  thing=atoi(authstr);

  if((thing<0) || (thing>db_top)) {
    write(fd,"bad obj\n",8);
    return;
  }

  if(db[thing].http_cnt<0) {
    write(fd,"incorrect obj\n",14);
    return;
  }

  if(strcmp(db[thing].http[0].authent+1,authstr+x)) {
    write(fd,"bad authent\n",12);
sprintf(buf2, "db[%d].http[0].authent+1=%s\nauthstr+%d=%s\n",thing,
db[thing].http[0].authent+1,  x,authstr+x);
write(fd,buf2,strlen(buf2));
    return;
  }

  did_it(db[thing].http[0].user, db[thing].http[0].control,
    NULL, 0, NULL, 0, A_HTIN);

  write(fd,"yay\n",4);
}

void http_wipe(thing)
  int thing;
{
  int x, y;

  for(x=db[thing].http_cnt;x>=1;x--) {
    for(y=db[thing].http[x].lines;y>=0;y--)
      free(db[thing].http[x].text[y]);
    free(db[thing].http[x].text);
  }
  if(db[thing].http_cnt>=0)
    free(db[thing].http);

  for(x=http_cnt;x>=0;x--) 
    if(http[x].user==thing) {
      for(y=http[x].lines;y>=0;y--)
        free(http[x].text[y]);
      free(http[x].text);
      http[http_cnt--]=http[x];
    }

  http=(struct http_struct*)realloc(http,
    sizeof(struct http_struct)*(http_cnt+1));
}

int hex2dec(inch)
  char inch;
{
  if((inch>='A') && (inch<='F')) return 10+(int)inch-(int)'A';
  else if((inch>='a') && (inch<='f')) return 10+(int)inch-(int)'a';
  else if((inch>='0') && (inch<='9')) return (int)inch-(int)'0';
  else return 0;
}
